import { Subject } from 'rxjs';
import { takeUntil } from 'rxjs/operators';
import { __extends } from 'tslib';
import { Component, TemplateRef, ElementRef, ViewChild, EventEmitter, Directive, Input, Output, ComponentFactoryResolver, ViewContainerRef, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { ObserversModule } from '@angular/cdk/observers';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapPopupPlaceholderComponent = /** @class */ (function () {
    function NgxBootstrapPopupPlaceholderComponent() {
        this.contentChanged = new EventEmitter();
    }
    Object.defineProperty(NgxBootstrapPopupPlaceholderComponent.prototype, "inserted", {
        get: /**
         * @return {?}
         */
        function () {
            return this._inserted;
        },
        set: /**
         * @param {?} inserted
         * @return {?}
         */
        function (inserted) {
            this._inserted = inserted;
            if (inserted instanceof TemplateRef) {
                this._template = inserted;
            }
            else {
                this._template = this.defaultTemplate;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapPopupPlaceholderComponent.prototype, "template", {
        get: /**
         * @return {?}
         */
        function () {
            return this._template;
        },
        enumerable: true,
        configurable: true
    });
    NgxBootstrapPopupPlaceholderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-bootstrap-popup-placeholder',
                    template: "\n    <div #insertedContent (cdkObserveContent)=\"contentChanged.emit($event)\">\n      <ng-container *ngTemplateOutlet=\"template\"></ng-container>\n    </div>\n    <ng-template #defaultTemplate>{{inserted}}</ng-template>\n  ",
                    styles: [':host {display: none;}']
                }] }
    ];
    NgxBootstrapPopupPlaceholderComponent.propDecorators = {
        defaultTemplate: [{ type: ViewChild, args: ['defaultTemplate',] }],
        insertedContent: [{ type: ViewChild, args: ['insertedContent',] }]
    };
    return NgxBootstrapPopupPlaceholderComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
var  /**
 * @abstract
 */
NgxBootstrapPopup = /** @class */ (function () {
    function NgxBootstrapPopup(_elementRef, _cfr, _vcr) {
        this._elementRef = _elementRef;
        this._cfr = _cfr;
        this._vcr = _vcr;
        this._ngUnsubscribe = new Subject();
        this._showing = false;
        this.clickDismissListener = null;
        this.events = new EventEmitter();
    }
    Object.defineProperty(NgxBootstrapPopup.prototype, "titleComponentRef", {
        get: /**
         * @return {?}
         */
        function () {
            return this._titleComponentRef;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapPopup.prototype, "contentComponentRef", {
        get: /**
         * @return {?}
         */
        function () {
            return this._contentComponentRef;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapPopup.prototype, "cfr", {
        get: /**
         * @return {?}
         */
        function () {
            return this._cfr;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapPopup.prototype, "vcr", {
        get: /**
         * @return {?}
         */
        function () {
            return this._vcr;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapPopup.prototype, "el", {
        get: /**
         * @return {?}
         */
        function () {
            return this._elementRef.nativeElement;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapPopup.prototype, "$el", {
        get: /**
         * @return {?}
         */
        function () {
            return jQuery(this.el);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapPopup.prototype, "bsInstance", {
        get: /**
         * @return {?}
         */
        function () {
            return this.$el.data('bs.' + this.popupType);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapPopup.prototype, "showing", {
        get: /**
         * @return {?}
         */
        function () {
            return this._showing;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapPopup.prototype, "jQueryEvents", {
        get: /**
         * @return {?}
         */
        function () {
            var _this = this;
            return ['show', 'inserted', 'shown', 'hide', 'hidden'].map(((/**
             * @param {?} t
             * @return {?}
             */
            function (t) { return t + ".bs." + _this.popupType; }))).join(' ');
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.create();
    };
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this._ngUnsubscribe.next();
        this._ngUnsubscribe.complete();
        this.$el[this.popupType]('dispose');
        this.$el.off(this.jQueryEvents, this.bsEventListener);
        if (this.clickDismissListener) {
            jQuery('body').off('click focusin', this.clickDismissListener);
        }
        if (this.titleComponentRef) {
            this.titleComponentRef.destroy();
        }
        if (this.contentComponentRef) {
            this.contentComponentRef.destroy();
        }
    };
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.create = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.bsEventListener = ((/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (_this.dismissOnClickOutside && event.type === 'shown') {
                _this.clickDismissListener = ((/**
                 * @param {?} clickEvent
                 * @return {?}
                 */
                function (clickEvent) {
                    if (_this.bsInstance.tip.contains(clickEvent.target)) {
                        return;
                    }
                    jQuery('body').off('click focusin', _this.clickDismissListener);
                    _this.clickDismissListener = null;
                    _this.hide();
                }));
                jQuery('body').on('click focusin', _this.clickDismissListener);
            }
            if (event.type === 'show') {
                _this._showing = true;
            }
            if (event.type === 'hidden') {
                jQuery('body').off('click focusin', _this.clickDismissListener);
                _this.clickDismissListener = null;
                _this._showing = false;
            }
            _this.events.emit(event);
        }));
        this.$el.on(this.jQueryEvents, this.bsEventListener);
        /** @type {?} */
        var options = this.getOptions();
        this.$el[this.popupType](options);
        this.updateEnabled();
    };
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.getOptions = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var options = Object.assign({}, this.options);
        if (this.title) {
            this._titleComponentRef = this.getPlaceholderComponent();
            this.titleComponentRef.instance.inserted = this.title;
            options.title = this.titleComponentRef.instance.insertedContent.nativeElement;
            options.html = true;
        }
        if (this.content) {
            this._contentComponentRef = this.getPlaceholderComponent();
            this.contentComponentRef.instance.inserted = this.content;
            options.content = this.contentComponentRef.instance.insertedContent.nativeElement;
            options.html = true;
        }
        return options;
    };
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.getPlaceholderComponent = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var factory = this.cfr.resolveComponentFactory(NgxBootstrapPopupPlaceholderComponent);
        /** @type {?} */
        var ref = this.vcr.createComponent(factory, 0);
        ref.instance.contentChanged
            .pipe(takeUntil(this._ngUnsubscribe))
            .subscribe((/**
         * @return {?}
         */
        function () {
            if (_this.showing) {
                _this.update();
            }
        }));
        return ref;
    };
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.show = /**
     * @return {?}
     */
    function () {
        this.$el[this.popupType]('show');
    };
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.hide = /**
     * @return {?}
     */
    function () {
        this.$el[this.popupType]('hide');
    };
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.toggle = /**
     * @return {?}
     */
    function () {
        this.$el[this.popupType]('toggle');
    };
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.enable = /**
     * @return {?}
     */
    function () {
        this.$el[this.popupType]('enable');
    };
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.disable = /**
     * @return {?}
     */
    function () {
        this.$el[this.popupType]('disable');
    };
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.toggleEnabled = /**
     * @return {?}
     */
    function () {
        this.$el[this.popupType]('toggleEnabled');
    };
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.update = /**
     * @return {?}
     */
    function () {
        this.$el[this.popupType]('update');
    };
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.updateTitle = /**
     * @return {?}
     */
    function () {
        if (this.titleComponentRef && this.title) {
            this.titleComponentRef.instance.inserted = this.title;
        }
    };
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.updateContent = /**
     * @return {?}
     */
    function () {
        if (this.contentComponentRef && this.content) {
            this.contentComponentRef.instance.inserted = this.content;
        }
    };
    /**
     * @return {?}
     */
    NgxBootstrapPopup.prototype.updateEnabled = /**
     * @return {?}
     */
    function () {
        if (this.bsInstance) {
            if (this.enabled) {
                this.enable();
            }
            else {
                this.disable();
            }
        }
    };
    return NgxBootstrapPopup;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapPopoverDirective = /** @class */ (function (_super) {
    __extends(NgxBootstrapPopoverDirective, _super);
    function NgxBootstrapPopoverDirective(elementRef, cfr, vcr) {
        var _this = _super.call(this, elementRef, cfr, vcr) || this;
        _this.popoverEnabled = true;
        _this.popoverDismissOnClickOutside = true;
        _this.popoverEvents = _this.events;
        return _this;
    }
    Object.defineProperty(NgxBootstrapPopoverDirective.prototype, "popupType", {
        get: /**
         * @return {?}
         */
        function () {
            return 'popover';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapPopoverDirective.prototype, "content", {
        get: /**
         * @return {?}
         */
        function () {
            return this.popoverContent || null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapPopoverDirective.prototype, "title", {
        get: /**
         * @return {?}
         */
        function () {
            return this.popoverTitle || null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapPopoverDirective.prototype, "dismissOnClickOutside", {
        get: /**
         * @return {?}
         */
        function () {
            return this.popoverDismissOnClickOutside;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapPopoverDirective.prototype, "enabled", {
        get: /**
         * @return {?}
         */
        function () {
            return this.popoverEnabled;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapPopoverDirective.prototype, "options", {
        get: /**
         * @return {?}
         */
        function () {
            return this.popoverOptions || null;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} changes
     * @return {?}
     */
    NgxBootstrapPopoverDirective.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if (changes.popoverEnabled !== undefined) {
            this.updateEnabled();
        }
        if (changes.popoverTitle) {
            this.updateTitle();
        }
        if (changes.popoverContent) {
            this.updateContent();
        }
    };
    NgxBootstrapPopoverDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngxBootstrapPopover]'
                },] }
    ];
    /** @nocollapse */
    NgxBootstrapPopoverDirective.ctorParameters = function () { return [
        { type: ElementRef },
        { type: ComponentFactoryResolver },
        { type: ViewContainerRef }
    ]; };
    NgxBootstrapPopoverDirective.propDecorators = {
        popoverTitle: [{ type: Input }],
        popoverContent: [{ type: Input }],
        popoverEnabled: [{ type: Input }],
        popoverDismissOnClickOutside: [{ type: Input }],
        popoverOptions: [{ type: Input }],
        popoverEvents: [{ type: Output }]
    };
    return NgxBootstrapPopoverDirective;
}(NgxBootstrapPopup));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapTooltipDirective = /** @class */ (function (_super) {
    __extends(NgxBootstrapTooltipDirective, _super);
    function NgxBootstrapTooltipDirective(elementRef, cfr, vcr) {
        var _this = _super.call(this, elementRef, cfr, vcr) || this;
        _this.tooltipEnabled = true;
        _this.tooltipDismissOnClickOutside = true;
        _this.tooltipEvents = _this.events;
        return _this;
    }
    Object.defineProperty(NgxBootstrapTooltipDirective.prototype, "popupType", {
        get: /**
         * @return {?}
         */
        function () {
            return 'tooltip';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapTooltipDirective.prototype, "content", {
        get: /**
         * @return {?}
         */
        function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapTooltipDirective.prototype, "title", {
        get: /**
         * @return {?}
         */
        function () {
            return this.tooltipTitle || null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapTooltipDirective.prototype, "dismissOnClickOutside", {
        get: /**
         * @return {?}
         */
        function () {
            return this.tooltipDismissOnClickOutside;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapTooltipDirective.prototype, "enabled", {
        get: /**
         * @return {?}
         */
        function () {
            return this.tooltipEnabled;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapTooltipDirective.prototype, "options", {
        get: /**
         * @return {?}
         */
        function () {
            return this.tooltipOptions || null;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} changes
     * @return {?}
     */
    NgxBootstrapTooltipDirective.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if (changes.tooltipEnabled !== undefined) {
            this.updateEnabled();
        }
        if (changes.tooltipTitle) {
            this.updateTitle();
        }
    };
    NgxBootstrapTooltipDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngxBootstrapTooltip]'
                },] }
    ];
    /** @nocollapse */
    NgxBootstrapTooltipDirective.ctorParameters = function () { return [
        { type: ElementRef },
        { type: ComponentFactoryResolver },
        { type: ViewContainerRef }
    ]; };
    NgxBootstrapTooltipDirective.propDecorators = {
        tooltipTitle: [{ type: Input }],
        tooltipEnabled: [{ type: Input }],
        tooltipDismissOnClickOutside: [{ type: Input }],
        tooltipOptions: [{ type: Input }],
        tooltipEvents: [{ type: Output }]
    };
    return NgxBootstrapTooltipDirective;
}(NgxBootstrapPopup));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapPopupModule = /** @class */ (function () {
    function NgxBootstrapPopupModule() {
    }
    NgxBootstrapPopupModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        NgxBootstrapPopupPlaceholderComponent,
                        NgxBootstrapTooltipDirective,
                        NgxBootstrapPopoverDirective,
                    ],
                    imports: [
                        CommonModule,
                        ObserversModule
                    ],
                    exports: [
                        NgxBootstrapTooltipDirective,
                        NgxBootstrapPopoverDirective
                    ],
                    entryComponents: [
                        NgxBootstrapPopupPlaceholderComponent
                    ]
                },] }
    ];
    return NgxBootstrapPopupModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxBootstrapPopoverDirective, NgxBootstrapTooltipDirective, NgxBootstrapPopup, NgxBootstrapPopupModule, NgxBootstrapPopupPlaceholderComponent as ɵa };

//# sourceMappingURL=nowzoo-ngx-bootstrap-popup.js.map